import java.awt.*;
import java.io.*;
import java.util.LinkedList;

public class BallType {


	public int smallest = 1;
	public int largest;
	public double scaleFactor;
	public Image [] balls;
	public String filename;
	public String fileExt;
	
	public int [] ballPointValue;
	public int [] ballBounceSize;
	
	public int noChildren = 2;
	public int [] childrenX = {-5,+5};
	public int [] childrenY = {0, 0};
	public double [] childrenD = {-1, 1};

	public int childType;
	public int thisType;
	
	public WillPang main;

	public void changeChildrenSettings (int childType, int noChildren, int [] childrenX, int [] childrenY, double [] childrenD) {

		if (childrenX.length == noChildren && childrenY.length == noChildren && childrenD.length == noChildren) {
		
			this.childType = childType;
			this.noChildren = noChildren;
			this.childrenX = childrenX;
			this.childrenY = childrenY;
			this.childrenD = childrenD;
		
		} else {
		
			System.out.println("Can't add children settings, error!");
		
		}
	}

	public BallType (int thisType, int smallest, int largest, String filename, String fileExt, double scaleFactor, int [] ballPointValue2, int [] ballBounceSize2, WillPang main) {
		this.largest = largest;
		this.smallest = smallest;
		this.filename = filename;
		this.fileExt = fileExt;
		this.scaleFactor = scaleFactor;
	//	this.ballPointValue = ballPointValue;
	//	this.ballBounceSize = ballBounceSize;
		ballPointValue = new int [smallest+largest];
		ballBounceSize = new int [smallest+largest];
		
		for (int i = smallest; i<=largest; i++) {
			ballPointValue[i] = ballPointValue2[i-smallest];
			ballBounceSize[i] = ballBounceSize2[i-smallest];			
		}
		
		this.main = main;
			
		this.thisType = thisType;
		childType = thisType;
		
		loadImages();
	}

//	public Ball (int x, int y, int ballSize, int initialVelocity, double horDirection, double scaleBounceFactor, int typeNo, WillPangImagePane imagePane) {
//

	public Ball [] produceChildren (Ball old) {
		Ball [] production = new Ball [noChildren];
		for (int i = 0; i<noChildren;i++) {
			int u = (int) old.u;
			if (u > -5) {
				u = -5;
			}
			int newBallPxlSize=0;
			try {
			while (balls[old.ballSize-1].getWidth(null) == -1);
	
			newBallPxlSize = balls[old.ballSize-1].getWidth(null);
			} catch (NullPointerException e) {
			}
			
			
			//Center initially
			int offset = old.ballPxlSize /2 - newBallPxlSize/2;
			int x = old.x + offset;
			int y = old.y + offset;
			production[i] = new Ball(x + childrenX[i],
									y + childrenY[i],
									old.ballSize-1,
									u,
									childrenD[i],
									childType,
									main.willPangImagePane);
		}
		return production;
	
	}

	//Load the ball images from a file
	public void loadImages () {
		balls = new Image [largest+smallest];
		int sizeNo = 0;
		
			try {
				for (sizeNo = smallest; sizeNo <= largest; sizeNo++) {

					balls [sizeNo] = main.getImage(filename + "-" + sizeNo + fileExt);

					//Wait for the image
					while (balls [sizeNo].getWidth(null) == -1);

					System.out.println("Loading: " + filename + "-" + sizeNo + fileExt);
					
					//Scale
					int width = balls [sizeNo].getWidth(null);
					width = main.scaleAndRound(width);
					
					//Scale ball
					balls  [sizeNo] = balls [sizeNo].getScaledInstance(width, width, Image.SCALE_SMOOTH);
					
					//If non-existant, error
					if (balls  [sizeNo] == null) {
						throw new Exception();
					}
				}
			} catch (Exception e) {
				//e.printStackTrace();
				System.out.println("Generating the remaining balls in this type...");

				int lastWorking = sizeNo-1;
				
				//wait
				while (balls [lastWorking].getWidth(null) == -1);
				
				
				int width = balls [lastWorking].getWidth(null);
				//de scale
				width = main.reverseScaleAndRound(width);
				// add ball scale
				width =  (int) Math.round(width * scaleFactor);
								
				//re scale
				width = main.scaleAndRound(width);
				//scale remaining
				for (sizeNo = sizeNo; sizeNo <= largest; sizeNo++) {
					balls [sizeNo] = balls [lastWorking].getScaledInstance(width, width, Image.SCALE_REPLICATE);
				}
				System.out.println("Done");
		}
	
	}
	
	
	public static BallType [] loadType (String filename, WillPang main) {
	
		LinkedList types = new LinkedList();
	
		try {
			// Open the file
			BufferedReader br = new BufferedReader(new FileReader(filename));
		
			//Ignore the first line
			br.readLine();
			
			String line = br.readLine();
			BallType currentType;
			int currentNum = 0;

			while (!line.equals("<eof>") && line != null) {
				String [] tmp;
				
				tmp = Delegate.stringCarver(br.readLine(), ",");
				int [] points = Delegate.string2int(tmp);
				
				tmp = Delegate.stringCarver(br.readLine(), ",");
				int [] bounce = Delegate.string2int(tmp);
				
				tmp = Delegate.stringCarver(br.readLine(), ",");
				currentType = new BallType(currentNum,
										Integer.parseInt(tmp[0]),
										Integer.parseInt(tmp[1]),	
										tmp[2],
										tmp[3],
										Double.parseDouble(tmp[4]),
										points,
										bounce,
										main);
								
				if (line.equals("<extended>")) {
					int childType = Integer.parseInt(br.readLine());
					int noChildren = Integer.parseInt(br.readLine());
					
					tmp = Delegate.stringCarver(br.readLine(), ",");
					int [] childrenX = Delegate.string2int(tmp);
					
					tmp = Delegate.stringCarver(br.readLine(), ",");
					int [] childrenY = Delegate.string2int(tmp);
					
					tmp = Delegate.stringCarver(br.readLine(), ",");
					double [] childrenD = Delegate.string2double(tmp);
					
					currentType.changeChildrenSettings(childType,
														noChildren,
														childrenX,
														childrenY,
														childrenD);								
					
					
				}		

				types.add(currentType);
				
				line = br.readLine();
				
				currentNum++;
			}
			
			
			
			br.close();
	
		} catch (IOException e) {
			System.out.println("Error loading type file " + filename);
		}
	
	
	
		//Convert to an array, and return
		BallType [] typesArray = new BallType[types.size()];
	
		for (int i = 0; i<types.size(); i++) {
			typesArray[i] = (BallType) types.get(i);
		}
	
		return typesArray;
		
	}

	

}