/** Contins information on a single level
 *
 *@author William Denniss
 *@version 5 June 2001 (WillPang v1.4)
 */

public class Level {


	//Instance variables
	
	// The number of points till the next level (-1) means unactivated
	public long pointsTillNext;
	
	// The number of seconds untill the next level (-1) means unactivated
	public long timeTillNext;

	// the list of balls that will be added when the level commences
	private Ball [] ballList;

	// the name of the level
	public String name;


	public long timeBetweenBallDrops;
	
	public int direction;
	
	public int minSizeOfBallDrops;
	public int maxSizeOfBallDrops;

	public int minXBallDrop;
	public int maxXBallDrop;
	public int minYBallDrop;
	public int maxYBallDrop;

	// The number of seconds between the last level finishing, and this one beginning
	public long pauseTime;
	
	// The number of seconds till this level starts (if the character has just died)
	public long startPauseTime;

	// determines wither or not all of the current balls will be wiped before the level starts
	public boolean wipeBalls;
	
	
	public int maxHarpoons;
	
	public boolean accumulative;
	
	// The starting position of the character, 0 = unchanged
	public int character1StartPos;
	
	// The number of seconds after the new balls are added before they start moving
	public int newBallPause;
	
	public int currentWeaponType;
	public int harpoonHeadFreezeTime;
	
	public int ballDropType;
	
	//To Impliment
	//public int character2StartPos
	public int backgroundIndex; //556556 = random
	public int startLevelSoundIndex; //556556 = random
	public int endLevelSoundIndex;
	public long timeVarient; //differ the balldropby
	
	// Advanced Constructor (reccommended)
	public Level (long pointsTillNext, long timeTillNext, Ball [] ballList, String name,
			long timeBetweenBallDrops, int direction, int minSizeOfBallDrops, int maxSizeOfBallDrops,
			int minXBallDrop, int maxXBallDrop, int minYBallDrop, int maxYBallDrop,
			long pauseTime, long startPauseTime, boolean wipeBalls, int maxHarpoons,
			boolean accumulative, int character1StartPos, int newBallPause,
			int currentWeaponType, int harpoonHeadFreezeTime, int backgroundIndex, int startLevelSoundIndex, int endLevelSoundIndex, long timeVarient, int ballDropType) {
			
		this.pointsTillNext = pointsTillNext;
		this.timeTillNext = timeTillNext;
		this.ballList = ballList;
		this.name = name;

		this.timeBetweenBallDrops = timeBetweenBallDrops;
		this.direction = direction;
		this.minSizeOfBallDrops = minSizeOfBallDrops;
		this.maxSizeOfBallDrops = maxSizeOfBallDrops;

		this.minXBallDrop = minXBallDrop;
		this.maxXBallDrop = maxXBallDrop;
		this.minYBallDrop = minYBallDrop;
		this.maxYBallDrop = maxYBallDrop;

		this.pauseTime = pauseTime;
		this.startPauseTime = startPauseTime;

		this.wipeBalls = wipeBalls;
		this.maxHarpoons = maxHarpoons;
	
		this.accumulative = accumulative;
		
		this.character1StartPos = character1StartPos;
		this.newBallPause = newBallPause;
		
		this.currentWeaponType = currentWeaponType;
		this.harpoonHeadFreezeTime = harpoonHeadFreezeTime;
		
		this.backgroundIndex = backgroundIndex;
		this.startLevelSoundIndex = startLevelSoundIndex;
		this.timeVarient = timeVarient;

		this.endLevelSoundIndex	= endLevelSoundIndex;	
		
		this.ballDropType = ballDropType;
		
	}								  
		
	//Basic Constructor (WillPangLevels v0.5)
	public Level (long pointsTillNext, Ball [] ballList, String name,
			int sizeOfBallDrops, long timeBetweenBallDrops, int pauseTime) {
		
		

		this.pointsTillNext = pointsTillNext;
		this.timeTillNext = -1;
		this.ballList = ballList;
		this.name = name;

		this.timeBetweenBallDrops = timeBetweenBallDrops;
		this.direction = 1;
		minSizeOfBallDrops = sizeOfBallDrops;
		maxSizeOfBallDrops = sizeOfBallDrops;
		
		this.minXBallDrop = 10;
		this.maxXBallDrop = 10;
		this.minYBallDrop = 10;
		this.maxYBallDrop = 10;

		this.pauseTime = pauseTime;
		this.startPauseTime = 2000;

		this.wipeBalls = false;
		this.maxHarpoons = 1;
		this.accumulative = false;
		
		this.character1StartPos = 0;
		this.newBallPause = 1000;
		
		this.currentWeaponType = 0;
		this.harpoonHeadFreezeTime = 0;
		
		this.backgroundIndex = 556556;
		this.startLevelSoundIndex = 556556;
		this.endLevelSoundIndex	= 556556;
		this.timeVarient = 0;
		
		
	}
	
	//Copies the ballList, else when the level is restarted, the balls will have moved
	public Ball [] getBallListCopy () {
		
		Ball [] newList = new Ball [ballList.length];
		Ball currentBall;
		
		for (int i = 0; i< ballList.length; i++) {
			currentBall = ballList[i];
			currentBall = new Ball(currentBall.x, currentBall.y, currentBall.ballSize, (int) currentBall.u, currentBall.horDirection, currentBall.type.thisType, currentBall.imagePane);
			newList[i] = currentBall;
		}
		
		return newList;
	
	}
	
}