; WillPang.nsi
;
; This script was adapted from example2.nsi that came with Nullsoft NSIS
;
; Edited by William Denniss

; The name of the installer
Name "WillPang1.5"

; The file to write
OutFile "WillPang1.5.exe"

;Set the installation icon
Icon ../../../tsins.ico

;Set the uninstall icon
UninstallIcon ../../../tsunins.ico

;Set Selected picture
EnabledBitmap ../../../sel.bmp

;Set unselected picture
DisabledBitmap ../../../unsel.bmp

;show the details while installing
ShowInstDetails show

LicenseText "You must agree to this license before you continue"
LicenseData ../../../license.txt



; The default installation directory
InstallDir $PROGRAMFILES\TankSoftware\WillPang
; Registry key to check for directory (so if you install again, it will 
; overwrite the old one automatically)
InstallDirRegKey HKLM SOFTWARE\WillPang "Install_Dir"

; The text to prompt the user to enter a directory
ComponentText "This will install WillPang and the WillPang Config Editor. Please choose if you want shortcuts to be added to the start menu."
; The text to prompt the user to enter a directory
DirText "Choose where you want the program to be installed.  It is recommended that you don't change it from the default directory."

; The stuff to install
Section "WillPang (required)"

	MessageBox MB_OK "Please note:  The Java runtime files must be installed for this program to work correctly."


  ; Set output path to the installation directory.
  SetOutPath $INSTDIR
  ; Put file there
	File "alt.wpbf"
  File "backgrounds.wpbf"
  File "demo.wpl"
  File "sounds.wpsf"
  File "type.wpbt"
  File "demo2.wpl"
  File "WillPang balls0.wplb"
	File "WillPang.bat"
	File "WillPang.html"
  File "WillPang.jar"
  File "WillPang1.5(source).ZIP"
	File "WillPang.ico"
	File "appletviewer.exe"
  SetOutPath $INSTDIR\images
	File "images\end.gif"
	File "images\intro.gif"
  SetOutPath $INSTDIR

  ; Write the installation path into the registry
  WriteRegStr HKLM SOFTWARE\WillPang "Install_Dir" "$INSTDIR"
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\WillPang" "DisplayName" "Tank Software - WillPang (remove only)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\WillPang" "UninstallString" '"$INSTDIR\uninstall.exe"'
SectionEnd

; optional section
Section "Start Menu Shortcuts"
  CreateDirectory "$SMPROGRAMS\Tank Software\WillPang"
  CreateShortCut "$SMPROGRAMS\Tank Software\WillPang\WillPang.lnk" "$INSTDIR\WillPang.bat" "" "$INSTDIR\WillPang.ico"
  CreateShortCut "$SMPROGRAMS\Tank Software\WillPang\Uninstall WillPang.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
  CreateShortCut "$SMPROGRAMS\Tank Software\WillPang\WillPang Directory.lnk" \
                 "$INSTDIR"	
SectionEnd

; uninstall stuff

UninstallText "This will uninstall WillPang. Hit next to continue."
UninstallExeName "uninstall.exe"

; special uninstall section.
Section "Uninstall"
	SetDetailsView show
  ; remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\WillPang"
  DeleteRegKey HKLM SOFTWARE\WillPang
  ; remove files
	Delete "$INSTDIR\appletviewer.exe"
	Delete "$INSTDIR\alt.wpbf"
	Delete "$INSTDIR\backgrounds.wpbf"
	Delete "$INSTDIR\demo.wpl"
	Delete "$INSTDIR\demo2.wpl"
	Delete "$INSTDIR\sounds.wpsf"
	Delete "$INSTDIR\type.wpbt"
	Delete "$INSTDIR\will.wpl"
	Delete "$INSTDIR\WillPang balls0.wplb"
	Delete "$INSTDIR\WillPang.bat"
	Delete "$INSTDIR\WillPang.html"
	Delete "$INSTDIR\WillPang.jar"
	Delete "$INSTDIR\WillPang.ico"
	Delete "$INSTDIR\appletviewer.exe"

  ; MUST REMOVE UNINSTALLER, too
  Delete $INSTDIR\uninstall.exe
  ; remove shortcuts, if any.
  Delete "$SMPROGRAMS\Tank Software\WillPang\*.*"
  ; remove directories used.
  RMDir "$SMPROGRAMS\Tank Software\WillPang"
  RMDir "$INSTDIR"
SectionEnd

; eof
